Index: code/branches/physics/src/orxonox/objects/worldentities/MobileEntity.cc
===================================================================
--- code/branches/physics/src/orxonox/objects/worldentities/MovableEntity.cc	(revision 2407)
+++ code/branches/physics/src/orxonox/objects/worldentities/MobileEntity.cc	(revision 2408)
@@ -28,5 +28,5 @@
 
 #include "OrxonoxStableHeaders.h"
-#include "MovableEntity.h"
+#include "MobileEntity.h"
 
 #include "BulletDynamics/Dynamics/btRigidBody.h"
@@ -42,7 +42,7 @@
 namespace orxonox
 {
-    MovableEntity::MovableEntity(BaseObject* creator) : WorldEntity(creator)
-    {
-        RegisterObject(MovableEntity);
+    MobileEntity::MobileEntity(BaseObject* creator) : WorldEntity(creator)
+    {
+        RegisterObject(MobileEntity);
 
         this->linearAcceleration_  = Vector3::ZERO;
@@ -54,22 +54,22 @@
     }
 
-    MovableEntity::~MovableEntity()
-    {
-    }
-
-    void MovableEntity::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(MovableEntity, XMLPort, xmlelement, mode);
-
-        XMLPortParamTemplate(MovableEntity, "velocity",     setVelocity,     getVelocity,     xmlelement, mode, const Vector3&);
-        XMLPortParamTemplate(MovableEntity, "rotationaxis", setRotationAxis, getRotationAxis, xmlelement, mode, const Vector3&);
-        XMLPortParam(MovableEntity, "rotationrate", setRotationRate, getRotationRate, xmlelement, mode);
-    }
-
-    void MovableEntity::registerVariables()
-    {
-    }
-
-    void MovableEntity::tick(float dt)
+    MobileEntity::~MobileEntity()
+    {
+    }
+
+    void MobileEntity::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(MobileEntity, XMLPort, xmlelement, mode);
+
+        XMLPortParamTemplate(MobileEntity, "velocity",     setVelocity,     getVelocity,     xmlelement, mode, const Vector3&);
+        XMLPortParamTemplate(MobileEntity, "rotationaxis", setRotationAxis, getRotationAxis, xmlelement, mode, const Vector3&);
+        XMLPortParam(MobileEntity, "rotationrate", setRotationRate, getRotationRate, xmlelement, mode);
+    }
+
+    void MobileEntity::registerVariables()
+    {
+    }
+
+    void MobileEntity::tick(float dt)
     {
         if (this->isActive())
@@ -104,5 +104,5 @@
     }
 
-    void MovableEntity::setPosition(const Vector3& position)
+    void MobileEntity::setPosition(const Vector3& position)
     {
         if (this->isDynamic())
@@ -117,5 +117,5 @@
     }
 
-    void MovableEntity::translate(const Vector3& distance, Ogre::Node::TransformSpace relativeTo)
+    void MobileEntity::translate(const Vector3& distance, Ogre::Node::TransformSpace relativeTo)
     {
         if (this->isDynamic())
@@ -130,5 +130,5 @@
     }
 
-    void MovableEntity::setOrientation(const Quaternion& orientation)
+    void MobileEntity::setOrientation(const Quaternion& orientation)
     {
         if (this->isDynamic())
@@ -143,5 +143,5 @@
     }
 
-    void MovableEntity::rotate(const Quaternion& rotation, Ogre::Node::TransformSpace relativeTo)
+    void MobileEntity::rotate(const Quaternion& rotation, Ogre::Node::TransformSpace relativeTo)
     {
         if (this->isDynamic())
@@ -157,5 +157,5 @@
     }
 
-    void MovableEntity::yaw(const Degree& angle, Ogre::Node::TransformSpace relativeTo)
+    void MobileEntity::yaw(const Degree& angle, Ogre::Node::TransformSpace relativeTo)
     {
         if (this->isDynamic())
@@ -172,5 +172,5 @@
     }
 
-    void MovableEntity::pitch(const Degree& angle, Ogre::Node::TransformSpace relativeTo)
+    void MobileEntity::pitch(const Degree& angle, Ogre::Node::TransformSpace relativeTo)
     {
         if (this->isDynamic())
@@ -187,5 +187,5 @@
     }
 
-    void MovableEntity::roll(const Degree& angle, Ogre::Node::TransformSpace relativeTo)
+    void MobileEntity::roll(const Degree& angle, Ogre::Node::TransformSpace relativeTo)
     {
         if (this->isDynamic())
@@ -202,5 +202,5 @@
     }
 
-    void MovableEntity::lookAt(const Vector3& target, Ogre::Node::TransformSpace relativeTo, const Vector3& localDirectionVector)
+    void MobileEntity::lookAt(const Vector3& target, Ogre::Node::TransformSpace relativeTo, const Vector3& localDirectionVector)
     {
         if (this->isDynamic())
@@ -215,5 +215,5 @@
     }
 
-    void MovableEntity::setDirection(const Vector3& direction, Ogre::Node::TransformSpace relativeTo, const Vector3& localDirectionVector)
+    void MobileEntity::setDirection(const Vector3& direction, Ogre::Node::TransformSpace relativeTo, const Vector3& localDirectionVector)
     {
         if (this->isDynamic())
@@ -228,5 +228,5 @@
     }
 
-    void MovableEntity::setVelocity(const Vector3& velocity)
+    void MobileEntity::setVelocity(const Vector3& velocity)
     {
         if (this->isDynamic())
@@ -237,5 +237,5 @@
     }
 
-    void MovableEntity::setAngularVelocity(const Vector3& velocity)
+    void MobileEntity::setAngularVelocity(const Vector3& velocity)
     {
         if (this->isDynamic())
@@ -246,5 +246,5 @@
     }
 
-    void MovableEntity::setAcceleration(const Vector3& acceleration)
+    void MobileEntity::setAcceleration(const Vector3& acceleration)
     {
         if (this->isDynamic())
@@ -254,5 +254,5 @@
     }
 
-    void MovableEntity::setAngularAcceleration(const Vector3& acceleration)
+    void MobileEntity::setAngularAcceleration(const Vector3& acceleration)
     {
         if (this->isDynamic())
@@ -265,9 +265,9 @@
     }
 
-    bool MovableEntity::isCollisionTypeLegal(WorldEntity::CollisionType type) const
+    bool MobileEntity::isCollisionTypeLegal(WorldEntity::CollisionType type) const
     {
         if (type == WorldEntity::Static)
         {
-            ThrowException(PhysicsViolation, "Cannot tell a MovableEntity to have static collision type");
+            ThrowException(PhysicsViolation, "Cannot tell a MobileEntity to have static collision type");
             return false;
         }
@@ -276,5 +276,5 @@
     }
 
-    void MovableEntity::setWorldTransform(const btTransform& worldTrans)
+    void MobileEntity::setWorldTransform(const btTransform& worldTrans)
     {
         // We use a dynamic body. So we translate our node accordingly.
@@ -293,5 +293,5 @@
     }
 
-    void MovableEntity::getWorldTransform(btTransform& worldTrans) const
+    void MobileEntity::getWorldTransform(btTransform& worldTrans) const
     {
         // We use a kinematic body